using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Contract;
namespace CMSMicroservice.Protobuf.Validator.Contract;

public class GetContractRequestValidator : AbstractValidator<GetContractRequest>
{
    public GetContractRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetContractRequest>.CreateWithOptions((GetContractRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
